Bug 439598 - broken spell-check defaults
broken spell-check defaults
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: firefox (Show other bugs)
22
All Linux
low Severity medium
: ---
: ---
Assigned To: Jan Horak
Fedora Extras Quality Assurance
: Reopened, Triaged
: 447435 447482 451671 485343 699183 1007653 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-03-29 10:24 EDT by Dan Winship
Modified: 2016-07-19 16:59 EDT (History)
44 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-07-19 16:49:13 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
reproduction (146.50 KB, image/png)
2008-04-01 04:40 EDT, Matěj Cepl
no flags Details
Upstream binary attempt to reproduce (143.95 KB, image/png)
2008-04-01 04:44 EDT, Matěj Cepl
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
Mozilla Foundation 481884 None None None Never
Mozilla Foundation 69687 None None None Never

  None (edit)
Description Dan Winship 2008-03-29 10:24:10 EDT
firefox for some reason has assumed that I want my spelling checked in "ar_DZ
(Algerian Arabic) and so is marking every word misspelled.

ar_DZ is the first entry in the pop-up list of available languages, which
probably has something to do with why it chose that. (I'm not sure why
hunspell-ar is even installed. Probably another bug somewhere else.) The list of
languages in that menu is completely unsorted; it starts out:

    ar_DZ
    en_ZW
    en_HK
    en_JM
    ...

and continues in completely random non-alphabetical order.

firefox-3.0-0.50.cvs20080327.fc9.x86_64
xulrunner-1.9-0.50.cvs20080327.fc9.x86_64
hunspell-1.2.1-6.fc9.x86_64
Comment 1 Matěj Cepl 2008-04-01 04:40:07 EDT
Created attachment 299869 [details]
reproduction

Yes, having en_HK as the my default spellchecking language seems weird to me as
well. Isn't this some byproduct of our effort to unify spellchecking libraries?
Comment 2 Matěj Cepl 2008-04-01 04:44:56 EDT
Created attachment 299870 [details]
Upstream binary attempt to reproduce

Upstream binary (with a dictionary downloaded to the profile) behaves
reasonably (and it is even translated, although cs_CZ dictionary is not
available yet).
Comment 3 Robin Norwood 2008-04-21 12:00:25 EDT
I'm seeing the same problem, fwiw, except with en_ZW as the default (the first
item on my list, just as en_HK is the first on Matej's list.)
Comment 4 Bug Zapper 2008-05-14 04:24:02 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Matěj Cepl 2008-05-26 10:58:28 EDT
*** Bug 447435 has been marked as a duplicate of this bug. ***
Comment 6 Matěj Cepl 2008-06-16 12:54:42 EDT
*** Bug 451671 has been marked as a duplicate of this bug. ***
Comment 7 Matěj Cepl 2008-08-27 04:17:18 EDT
*** Bug 447482 has been marked as a duplicate of this bug. ***
Comment 8 joshua 2008-12-12 10:45:33 EST
I'm seeing the same problem in F10.... en_ZW is first in the list, so it gets used :-(
Comment 9 Andre Robatino 2009-02-02 18:25:26 EST
Yes, en_ZW is my default value as well.
Comment 10 Matěj Cepl 2009-02-13 08:24:41 EST
*** Bug 485343 has been marked as a duplicate of this bug. ***
Comment 11 Basil Mohamed Gohar 2009-05-28 05:31:22 EDT
The same thing happened to me with Thunderbird on Rawhide.  The language was ar_DZ, something I've never selected.
Comment 12 Bug Zapper 2009-06-09 05:30:33 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 11 development cycle.
Changing version to '11'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 13 Michael Hampton 2009-07-15 07:40:25 EDT
This remains an issue in Fedora 11 with firefox-3.5-1.fc11.x86_64.

While us Americans can work around this issue by writing in the Queen's English, and non-Americans might even prefer if we did, it hardly seems like an ideal solution. :-)
Comment 14 Bill Wenrich 2009-07-27 02:27:12 EDT
Confirmed on Fedora 11 32-bit running firefox-3.5-1.fc11.i586.
The default language is set to en_HK, the first item in the dictionary list.

Workaround: 1) Learn a foreign language. or 2) Go to about:config and change the value of "spellchecker.dictionary" to your local language code which is quite possibly en_US or en_UK and not ar_DZ.

The workaround correctly sets the spell-check dictionary and persists through a restart of Firefox.
Comment 15 Michael Hampton 2009-07-27 04:44:02 EDT
That's interesting. spellchecker.dictionary was indeed set to en_HK. Resetting the value did not fix the problem; it came back after restart set to en_HK again. But manually setting it to en_US did work.
Comment 16 Andre Robatino 2009-07-27 06:13:37 EDT
Mine was set to en_ZW on F11 running firefox-3.5.1-1.fc11.x86_64.  I'm fairly sure I never changed the setting, at least not in about:config.  The setting survives a restart after setting it in about:config.
Comment 17 Andre Robatino 2009-07-27 06:21:26 EDT
Never mind, I notice that's already been reported.  I've been restoring the ~/.mozilla directory for a few years after each clean install which is probably why mine is the first item on the list from an earlier version.
Comment 18 Andrew McNabb 2009-11-17 16:19:41 EST
I'm having this problem in Fedora 12 (with en_HK as the default language).
Comment 19 Aron Parsons 2010-02-03 14:51:26 EST
Set to to en_{HK,ZW} by default on every F12 system that I use Firefox on.
Comment 20 Braden McDaniel 2010-05-27 23:27:50 EDT
This problem isn't exclusive to Firefox; I'm observing the same thing in Empathy (Fedora 13). I don't know whether that means that there's a common source of the problem, or that it's been duplicated elsewhere.
Comment 21 Bug Zapper 2010-11-04 07:58:47 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 22 Dan Winship 2010-11-04 08:36:47 EDT
still exists in F14 with firefox 3.6.10
Comment 23 Christopher Aillon 2011-05-10 15:47:35 EDT
*** Bug 699183 has been marked as a duplicate of this bug. ***
Comment 24 Yajo 2011-07-07 09:36:08 EDT
Fedora 15, Firefox 5, bug persists.
Comment 25 Guillaume AMAT 2012-01-10 04:06:23 EST
Fedora 16, I must reset the spellchecker everyday in about:config.
It's sooooooo painfull and I don't understand why this stupid bug annoying me for years!

Please! Someone can save us?
Comment 26 Jan Horak 2012-01-10 06:54:26 EST
(In reply to comment #25)
> Fedora 16, I must reset the spellchecker everyday in about:config.
> It's sooooooo painfull and I don't understand why this stupid bug annoying me
> for years!
> 
> Please! Someone can save us?

Did you try to change Spell checking language by: RMB on input field->Languages->[Your preferred language]?
Does this settings persist (this can be found in about:config spellchecker.dictionary)?
Comment 27 Guillaume AMAT 2012-01-10 07:53:41 EST
Okay!

Despite my change in about:config the language in this context menu was wrong.
I selected the good one and will check about:config in the next days.

Thanks a lot dude!
Comment 28 Guillaume AMAT 2012-01-11 05:39:27 EST
Today, same bug... :(
The selected language is the first in the list.
I think I will create a new firefox profile, mine is 2/3 years old.

Thanks again!
Comment 30 Bill McGonigle 2012-03-05 00:58:18 EST
Same here on Fedora 16 (and previous).  Recently, the list of dictionaries has become apparently completely unsorted, so finding my language is now an extra challenge.  

Also, I keep finding spelling disabled in text fields, so I frequently have to keep re-enabling it ("Check Spelling" via right-click context menu).  I think that part is new as of FF10 - not sure if it's related.

As of four years ago, it was felt that this is not a problem present in upstream.  Anybody know if that's still true, and if so which one of our patches is the cause of these problems?
Comment 31 Neil Bryant 2012-03-05 22:40:13 EST
FWIW (and to get emails) I get the same thing, except that on my machine it defaults to German/Austrian, which I don't speak. It is the first in my list of available languages.

Firefox 10.0.1 on Fedora 15, at the moment. This issue has been going on for a couple of updates of Firefox, and at least one major version.

I keep a second, bare FF profile (no extensions) for temp stuff, and it is also affected.

Looking at prefs.js, the value looks like it's persistent:
user_pref("spellchecker.dictionary", "en_US");
it's there while FF is shut down, but when I start it up, it just seems to reset to null in the list.
Comment 32 Neil Bryant 2012-03-05 23:04:51 EST
Incidentally, I also tried creating a user.js file, with:
user_pref("spellchecker.dictionary", "en_US");

that also gets ignored.
Comment 33 Yajo 2012-03-06 03:16:48 EST
I have a Windows machine in which this gets me crazy.

For instance, when I use Gmail (almost always in Spanish), FF assumes I want it in English and I have to change it everyday. Then I come to write this bug report and FF assumes I want it in Spanish.

So it seems like the wrong choice of dictionary is an upstream issue...

On the other hand, the problem of having tens of dictionaries installed seems to be Fedora's, because here in Windows I only have the dictionaries that I installed by myself.
Comment 34 Hollis Blanchard 2012-05-07 18:32:01 EDT
Still a problem with Firefox 11.0 on Fedora 16. 

For the record, my language resets to de_AT (German/Austria), the first language in the massive unsorted list of available languages in the text field right-click->Languages menu.
Comment 35 Russell Harrison 2012-08-13 10:53:20 EDT
Confirming the problem is still present for F17.
Comment 36 Fedora End Of Life 2012-08-16 17:58:35 EDT
This message is a notice that Fedora 14 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 14. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained.  At this time, all open bugs with a Fedora 'version'
of '14' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this 
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen 
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we were unable to fix it before Fedora 14 reached end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" (top right of this page) and open it against that 
version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 37 Jason Tibbitts 2012-08-16 18:01:56 EDT
Comment 35 says still present in f17, but the Version field wasn't updated. Reopening.
Comment 38 Garrett Mitchener 2013-01-25 10:07:54 EST
Most definitely still in f17, saw it just now.
Comment 39 Heiko Adams 2013-03-03 17:32:39 EST
This problem is still present in f18 and ff19
Comment 42 Fedora End Of Life 2013-04-03 16:01:58 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 43 Heiko Adams 2013-06-29 03:18:07 EDT
Any progress on this nasty bug?
Comment 44 Heiko Adams 2013-06-29 03:28:35 EDT
If I understand the problem correctly hunspell is the one who makes the trouble so why not stop using hunspell and switch over to dictionaries provided by AMO? In that case everyone could decide on his own which dicts he needs and install only the required ones.
Comment 45 John Griffiths 2013-09-11 08:57:41 EDT
This is happening for me as well. I select en-US and Firefox will change it to something else. Right now it has selected English (Zambia). It will also select English (Canada) or some other random English. I only have English dictionary installed, so I guess I am fortunate that Firefox doesn't change to Japanese or Greek. Not that there is anything wrong with those languages if you speak or write them; I don't.

The language to be used should be a USER selection and not something Firefox just decides to use.
Comment 46 Ed Marshall 2013-09-23 21:46:45 EDT
Just saw this on F19. Firefox's about:config showed an overridden spellchecker.dictionary value of "en_ZW" rather than blank (or "en_US").
Comment 47 Bill McGonigle 2013-09-24 19:08:00 EDT
A few notes:

1) This has been so much worse (every hour or so) on f19 that I decided to dig into it a bit.

2) It looks like system-hunspell is configured in xulrunner, not the firefox build, per se.  People here report both thunderbird and firefox trouble, so that makes some sense.  The component may be wrong on this bug.

3) I built a version of xulrunner without system-hunspell on f19 and so far today, it's been stable.  That's a sample size of 1 (2 if you count firefox and thunderbird), so I put the build up here, if anybody else wants to give it a go:

  http://www.bfccomputing.com/downloads/fedora/xulrunner/

(currently uploading on a slow connection - the SRPM is 119243348 long, md5 of d95dd31f5dcabdcff2ec3af8658edb75).  The two changed files are the .spec and xulrunner-mozconfig.

4) It looks to me like perhaps --enable-system-hunspell functionality is buggy upstream.  Assuming others can verify that the mozilla hunspell fixes their issue (I'll write back here if/when it ever goes wrong on my machines), it makes more sense to ship upstream hunspell so the apps are usable.  It's been five years and nobody has fixed this, so it may not be all that easy a thing to do.  system-hunspell has been reverted in the past, according to the spec comments.
Comment 48 Bill McGonigle 2013-11-04 11:59:39 EST
sorry for the delay - after running for a while, the same behavior returned, even without the system hunspell.  It looks like this is a xulrunner upstream problem.
Comment 49 David.Feuer 2014-04-05 20:53:19 EDT
This issue remains in F20. Please update the version field. It likes Zimbabwean and Zambian English for some reason.
Comment 50 Fedora End Of Life 2015-05-29 04:34:43 EDT
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 51 Jan Horak 2015-06-22 08:35:27 EDT
I believe the problem mentioned in comment 1  has been fixed lately. Problems with "Zimbabwean and Zambian English" is different issue and probably will never be fixed because it can't be. At least on Fedora.

Firefox/Thunderbird in Fedora is using system dictionaries from /usr/share/myspell. Check out it's content. It links various English dialects/locales to en_US or en_GB dictionaries. All this symlinks are created by hunspell-en package. To get rid of them, you can remove hunspell-en and install hunspell-en-GB or hunspell-en-US package according to the locale you want to use.

When Firefox find 'lang=en' attribute on the page where the input is possible it sets dictionary to the first 'en' locale it have in the loaded dictionary list. It's not en-US or en-GB dictionary but this surprisingly Zimbabwean English (list is unsorted). Firefox is doing this because by default no dictionary is installed and user is supposed to download dictionary which they'd like to use. In this case picking the first 'en-whathever' dictionary makes sense, because user know what he wants and actually installed it. 

So there's no way to fix that in Mozilla code because our changes to improve the situation (like some default en-US mapping) is not relevant to them.

Any known workaround for me is:
yum remove hunspell-en
yum install hunspell-en-US
or
yum install hunspell-en-GB
to avoid load of English dictionaries.

Please recheck that above information is correct and issue mentioned in comment 1 is resolved for you that we can close this bug. Thank you.
Comment 52 Dan Winship 2015-06-22 09:45:57 EDT
(In reply to Jan Horak from comment #51)
> When Firefox find 'lang=en' attribute on the page where the input is
> possible it sets dictionary to the first 'en' locale it have in the loaded
> dictionary list. It's not en-US or en-GB dictionary but this surprisingly
> Zimbabwean English (list is unsorted). Firefox is doing this because by
> default no dictionary is installed and user is supposed to download
> dictionary which they'd like to use. In this case picking the first
> 'en-whathever' dictionary makes sense, because user know what he wants and
> actually installed it. 

My $LANG is en_US.UTF-8. And in the Preferences -> Content -> Languages dialog, "en-us" is listed first (presumably having been defaulted from $LANG). So Firefox knows that I want en-US, and it should give me that.
Comment 53 Jan Horak 2015-06-22 10:10:38 EDT
Hm, let me check that Language preference if we can make any use of it.
Comment 54 Paul DeStefano 2015-07-22 01:11:22 EDT
Wow, 7 years is a really long time.

As far as I know, this problem did not go away.  I believe I had done the same as Jan Horak and removed hunspell-en (and the libreoffice-lanpack-en which depends on it).

What I don't understand is why FF picks Malawi for me.  It is *not* the first dictionary in the list on my system.  I don't know if this is a different bug or if it's the same bug and the fact that it picks the first dictionary in the list for *some* people is a red-herring.

After F22 upgrade, the problem returned and I didn't remember this workaround.  Thanks Jan for reporting it here.

So, this is not fixed and applies to F22 and FF39.
Comment 55 Matthew Miller 2015-10-16 14:34:12 EDT
*** Bug 1007653 has been marked as a duplicate of this bug. ***
Comment 56 Fedora End Of Life 2015-11-04 10:19:43 EST
This message is a reminder that Fedora 21 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 21. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '21'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 21 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 57 Jason Tibbitts 2015-11-04 10:30:04 EST
Bumping to F22 since it was mentioned that this happens there and I'm pretty sure I've seen it.  I now run firefox-beta most of the time, and since it has only the US English dictionary by default, I conveniently don't see this issue.
Comment 58 Garrett Mitchener 2015-11-04 13:36:18 EST
Yes, I still see it on F22. I've removed a lot of stuff so that the only dictionaries installed are English-US and English-UK. I set it to US, and every so often it flips back to UK.
Comment 59 Bill McGonigle 2015-11-04 14:59:31 EST
Perhaps the long night ends with Firefox 43?  

 https://hg.mozilla.org/mozilla-central/rev/08cd638ca00d

I haven't tried applying to 42 yet.  If somebody else does a build first, I'll test.
Comment 60 Fedora End Of Life 2016-07-19 16:49:13 EDT
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 61 Michael Hampton 2016-07-19 16:59:12 EDT
Just checked this in firefox-47.0-4.fc23.x86_64 and it does indeed seem to be working correctly (finally). With US English, "colour" is marked as misspelled and "color" is not, which is the expected behavior.

Note You need to log in before you can comment on or make changes to this bug.